<?php
  
  $session = $this->getSession();
  $filter_html = new Yab_Filter_Html();
  
  $sitefouille_id = $session->get('sitefouille_id') ;

  $option_height = (!empty($option_height) ) ? $option_height : '400px' ;
  $network = array() ;
  
  foreach($network_racines as $key_racine => $value_racine ) {
    
    $poid = $value_racine->get('poid') ; 
    
    $us_id_p = $value_racine->get('posterieur_id') ;
    $us_nom_p =  str_replace("/", "<br>" ,$value_racine->get('us_posterieur') ) ;
    $us_id_ident_p = hash('crc32', $us_id_p ) ;    
    $title_p = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_p.'\')">D&eacute;tails</a>' ;
    $color_p = '#'.substr(hash('crc32', $value_racine->get('us_posterieur_contexte') ), -6 ) ;
    $level_p = $value_racine->get('level_posterieur') ;
    
    $us_id_a = $value_racine->get('anterieur_id') ;
    $us_nom_a = str_replace("/", "<br>" ,$value_racine->get('us_anterieur') ) ;
    $us_id_ident_a = hash('crc32', $us_id_a ) ;  
    $title_a = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_a.'\')">D&eacute;tails</a>' ;
    $color_a = '#'.substr( hash('crc32', $value_racine->get('us_anterieur_contexte') ), -6 ) ;
    // $level_a = $value_racine->get('level_anterieur') ;
    $level_a = $level_p + 1 ;
    
    $network['nodes'][$us_id_p] = array(
      'id' => $us_id_ident_p,
      'label' => $us_nom_p,
      // 'allowedToMoveY' => 'false',
      'title' => $title_p,
      'color' => array ( 'background' => $color_p ),
      'shape' => 'box',
      'level' => 1,
      'root' => $us_id_p,
      'parent' => 0,
      'poid' =>  $poid,      
    );
     
    $network['nodes'][$us_id_a] = array(
      'id' => $us_id_ident_a,
      'label' => $us_nom_a,
      // 'allowedToMoveY' => 'false',
      'title' => $title_a,
      'color' => array ( 'background' => $color_a ),
      'shape' => 'box', 
      'level' => 2,
      'root' => $us_id_p,
      'parent' => $us_id_p,
      'poid' =>  $poid,
    );
   
    $edges = array(
      'from' => $us_id_ident_p,
      'to' => $us_id_ident_a,
      'style' => 'arrow',
      'root' => $us_id_p,
      'parent' => $us_id_p,
      'level' => 1,
      'poid' =>  $poid,     
    );
    /*
    if( $value_racine->get('incertitude') ){
      $edges['style'] = 'dash-line' ;
      $edges['label'] = 'incertain' ; 
    } else {
      $edges['style'] = 'arrow' ;
    }
    */
    $network['edges'][$us_id_p] = $edges ;
    
  } 
  
  foreach($network_branches as $key_branches => $anteroposterite ) {
    
    $us_id_p = $anteroposterite->get('posterieur_id') ;
    $us_nom_p =  str_replace("/", "<br>" ,$anteroposterite->get('us_posterieur') ) ;
    $us_id_ident_p = hash('crc32', $us_id_p ) ;    
    $title_p = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_p.'\')">D&eacute;tails</a>' ;
    $color_p = '#'.substr(hash('crc32', $anteroposterite->get('us_posterieur_contexte') ), -6 ) ;
    
    $parent_p = (!empty($network['nodes'][$us_id_p]['parent'])) ?  $network['nodes'][$us_id_p]['parent'] : null ;
    $level_p = (!empty( $parent_p )) ?  $network['nodes'][$parent_p]['level'] + 1 : 2 ; 
    
    $us_id_a = $anteroposterite->get('anterieur_id') ;
    $us_nom_a = str_replace("/", "<br>" ,$anteroposterite->get('us_anterieur') ) ;
    $us_id_ident_a = hash('crc32', $us_id_a ) ;  
    $title_a = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_a.'\')">D&eacute;tails</a>' ;
    $color_a = '#'.substr( hash('crc32', $anteroposterite->get('us_anterieur_contexte') ), -6 ) ;

    $parent_a = (!empty($network['nodes'][$us_id_a]['parent'])) ?  $network['nodes'][$us_id_a]['parent'] : $us_id_p ;
    $level_a = (!empty( $parent_a ) && (!empty($network['nodes'][$parent_a]['level']) ) ) ?  $network['nodes'][$parent_a]['level'] + 1 : $level_p + 1  ; 

    
    $poid = $anteroposterite->get('poid') ;    
    $poid_a =  (!empty($network['nodes'][$us_id_p]['poid'])) ?  $network['nodes'][$us_id_p]['poid'] + 1 : $poid + 1  ;
    $racine_id = (!empty($network['nodes'][$us_id_p]['root'])) ?  $network['nodes'][$us_id_p]['root'] : $us_id_p ;
     
    /*
    $network['nodes'][$us_id_p] = array(
      'id' => $us_id_ident_p,
      'label' => $us_nom_p,
      // 'allowedToMoveY' => 'false',
      'title' => $title_p,
      'color' => array ( 'background' => $color_p ),
      'shape' => 'box',      
    );
    */
    
    $network['nodes'][$us_id_p]['poid'] = $poid_a ;
    $network['nodes'][$us_id_p]['group'] = $racine_id ;
    $network['nodes'][$racine_id]['poid'] = $poid_a ;
    
    // $level_p = !empty( $network['nodes'][$us_id_p]['level'] ) ? $network['nodes'][$us_id_p]['level'] : $level_p ;
     
    $network['nodes'][$us_id_a] = array(
      'id' => $us_id_ident_a,
      'label' => $us_nom_a,
      // 'allowedToMoveY' => 'false',
      'title' => $title_a,
      'color' => array ( 'background' => $color_a ),
      'shape' => 'box',
      'level' => $level_a,       
      'root' => $racine_id,
      'parent' => $parent_a,
      'poid' =>  $poid_a,     
    );

    $edges = array(
      'from' => $us_id_ident_p,
      'to' => $us_id_ident_a,
      'length' => 150,
      'style' => 'arrow',
      'root' => $us_id_p,
      'parent' => $us_id_p,
      'level' => $level_p,
      'poid' =>  $poid,       
    );
    /*
    if( $anteroposterite->get('incertitude') ){
      $edges['style'] = 'dash-line' ;
      $edges['label'] = 'incertain' ; 
    } else {
      $edges['style'] = 'arrow' ;
    } 
    */ 
    $network['edges'][$us_id_p] = $edges ;

  } 

  foreach($network_synchronisation as  $key_synchro => $synchronisation ) {
    $us_id_l = $synchronisation->get('synchro1_id') ;
    $us_nom_l = str_replace("/", "<br>" ,$synchronisation->get('us_left_synchro')) ;
    $us_id_ident_l = hash('crc32', $us_id_l ) ;
    $title_l = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_l.'\')">D&eacute;tails</a>' ;
    $color_l = '#'.substr(hash('crc32', $synchronisation->get('us_left_contexte') ), -6 ) ;
    
    $parent_l = (!empty($network['nodes'][$us_id_l]['parent'])) ?  $network['nodes'][$us_id_l]['parent'] : null ;
    $level_l = isset( $network['nodes'][$us_id_l]['level'] ) ? $network['nodes'][$us_id_l]['level'] : 0 ;
    $level_l = (!empty( $parent_l )) ?  $network['nodes'][$parent_l]['level'] + 1 : $level_l ; 
    
    
    $us_id_r = $synchronisation->get('synchro2_id') ;
    $us_nom_r = str_replace("/", "<br>" ,$synchronisation->get('us_right_synchro')) ;
    $us_id_ident_r = hash('crc32', $us_id_r ) ;  
    $title_r = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_r.'\')">D&eacute;tails</a>' ;
    $color_r = '#'.substr(hash('crc32', $synchronisation->get('us_right_contexte') ), -6 ) ;
    
    $parent_r = (!empty($network['nodes'][$us_id_r]['parent'])) ?  $network['nodes'][$us_id_r]['parent'] : null ;
    $level_r = isset( $network['nodes'][$us_id_r]['level'] ) ? $network['nodes'][$us_id_r]['level'] : 0 ;
    $level_r = (!empty( $parent_r )) ?  $network['nodes'][$parent_r]['level'] + 1 : $level_r ; 
    
    $poid = $synchronisation->get('poid') ;
    
    $poid_l =  (!empty($network['nodes'][$us_id_l]['poid'])) ?  $network['nodes'][$us_id_l]['poid'] + 1 : $poid + 1  ; 
    $racine_id = (!empty($network['nodes'][$us_id_l]['group'])) ?  $network['nodes'][$us_id_l]['group'] : $us_id_l ; 
    
    $level = (!empty($level_l) ) ? $level_l : $level_r ;
    
    // $network['nodes'][$us_id_l]['level'] = $level ;
    // $network['nodes'][$us_id_r]['level'] = $level ;
    
    
    if ( !empty($network['nodes'][$us_id_l] ) ) {
      $network['nodes'][$us_id_l]['poid'] = $poid_l ;
    } else {
      $network['nodes'][$us_id_l] = array(
        'id' => $us_id_ident_l,
        'label' => $us_nom_l,
        // 'allowedToMoveY' => 'false',
        'title' => $title_l,
        'color' => array ( 'background' => $color_l ),
        'shape' => 'box',
        'level' => $level,       
        'root' => $racine_id,
        'parent' => $parent_l,
        'poid' =>  $poid_l,     
      );    
    }
    $network['nodes'][$racine_id]['poid'] = $poid_l ;

    if ( !empty($network['nodes'][$us_id_r] ) ) {
    
      $network['nodes'][$us_id_r]['poid'] = $poid_l ;
    } else {
      $network['nodes'][$us_id_r] = array(
        'id' => $us_id_ident_r,
        'label' => $us_nom_r,
        // 'allowedToMoveY' => 'false',
        'title' => $title_r,
        'color' => array ( 'background' => $color_r ),
        'shape' => 'box',
        'level' => $level,       
        'root' => $racine_id,
        'parent' => $parent_r,
        'poid' =>  $poid_l,     
      );    
    }
    $network['nodes'][$racine_id]['poid'] = $poid_l ;

    $edges = array(
      'from' => $us_id_ident_l,
      'to' => $us_id_ident_r,
      // 'color' => 'red',
      'length' => 50,
      'root' => $racine_id,
      'parent' => $parent_l,
      'level' => $level,
      'poid' =>  $poid_l, 

    );
    /*
    if( $synchronisation->get('incertitude') ){
      $edges['style'] = 'dash-line' ;
      $edges['label'] = 'incertain' ; 
    } 
    */ 
    $network['edges'][$us_id_l] = $edges ;

  } 

  foreach($network['nodes'] as $node ) {
    $racine_id = $node['root'] ;
    $racine_poid = $network['nodes'][$racine_id]['poid'] ;
    $node['poid'] = $racine_poid ; 
    $network_nodes[] = $node ;
  } 
  
  foreach($network['edges'] as $edge ) {
    $racine_id = $edge['root'] ;
    $racine_poid = $network['edges'][$racine_id]['poid'] ;
    $edge['poid'] = $racine_poid ; 
    $network_edges[] = $edge ;
  } 
   
  function array_orderby()
  {
      $args = func_get_args();
      $data = array_shift($args);
      foreach ($args as $n => $field) {
          if (is_string($field)) {
              $tmp = array();
              foreach ($data as $key => $row)
                  $tmp[$key] = $row[$field];
              $args[$n] = $tmp;
              }
      }
      $args[] = &$data;
      call_user_func_array('array_multisort', $args);
      return array_pop($args);
  }
  
  $network_nodes = array_orderby($network_nodes, 'poid', SORT_DESC, 'level', SORT_ASC ) ;
  
  $network_edges = array_orderby($network_edges, 'poid', SORT_DESC, 'level', SORT_ASC ) ;
  
  $network_nodes = json_encode($network_nodes,  JSON_UNESCAPED_SLASHES )  ;
  $network_edges = json_encode($network_edges )  ;

  // identifiant unique de la div d'affichage 
  $unique_div = rand();
  
  // redirection de page Plein ecran / Dashboard
  
  $controller = $this->getRequest()->getController();
  $action = $this->getRequest()->getAction() ;
  $controller_action = $controller.'_'.$action ; 
  if ( $controller_action == 'Dashboard_show' ) {
    $redict_url = $this->getRequest('Dashboard_Us', 'UsNetwork', array('layout' => 1, 'height' => '600px' )) ;
    $redict_glyph = 'glyphicon glyphicon-resize-full' ;
    $redict_tooltip = 'Mettre en plein &eacute;cran ' ;
    
  } else {
    $redict_url = $this->getRequest('Dashboard', 'show') ;
    $redict_glyph = 'glyphicon glyphicon-resize-small' ;
    $redict_tooltip = 'Revenir au tableau de bord ' ;
  }

?>
  <style type="text/css">
    #sdf_us_network {
      /* width: 600px; 
      height: 400px;
      border: 1px solid lightgray;
      */
    }

  </style>
<div class="col-md-12">
  <div class="panel panel-default">
    <div class="panel-heading"> Unit&eacute;s Stratigraphiques  
      <div class="pull-right">                                
        <div class="btn-group">
          <a href="<?php echo $redict_url  ; ?>" >                                    
            <button 
              class="btn btn-default btn-xs"
              data-original-title="<?php echo $redict_tooltip ; ?>"
              data-toggle="tooltip"
              data-placement="bottom"
            >      
                <span
                  class="glyphicon <?php echo $redict_glyph  ; ?>" 
                  aria-hidden="true"
                ></span>
            </button>
          </a>
        </div>                            
      </div>
      
    </div>    
    <div class="panel-body" style="background-image: url('<?php //echo $request->getBaseUrl(); ?>/images/ilot_cygne_bg.jpg') ;">
      <div id="sdf_us_network_<?php echo $unique_div  ; ?>" >chargement ... </div>
    </div>
    
  </div>
</div>


<script type="text/javascript">
    
  function showDetailUsNetwork(us_id)
  {
     $.ajax({
      type:"POST",
			url: "<?php echo $this->getRequest('Dashboard_us','Show' ) ; ?>"+us_id,
			data: "id="+us_id,
      success: function(returnData) {
        // Affichage du modal (boite de dialogue)
        $('#modalTitle').html('Unite Stratigraphique');
        $('#modalBody').html(returnData);
        $('#myModal').modal();
        if(data.error)
          alert(data.error);
       },
       error: function(returnData) {
        alert('Une erreur est survenue.'); 
       }
      });
  } 
      
    /* US Network */
    var network_us_network = null;
    var layoutMethod_us_network = "direction";
    // var layoutMethod_us_network = "hubsize";
    var direction_us_network = "UD";
    var option_height = "<?php echo $option_height ; ?>" ; 
    
    var nodes_us_network = <?php echo $network_nodes ; ?> ;
    var edges_us_network = <?php echo $network_edges ; ?> ;
    
    // console.log(nodes_us_network) ;  
    // create a network
    var container_us_network = document.getElementById('sdf_us_network_<?php echo $unique_div  ; ?>');
    var data_us_network = {
        nodes: nodes_us_network,
        edges: edges_us_network
        // dot: dot_us_network,
    };

     var options_us_network = {
      width:  "100%",
      height: option_height,
      smoothCurves:false,
      // configurePhysics:true,
      physics: {
        hierarchicalRepulsion: {
          centralGravity: 0.4
        }
      },
      hierarchicalLayout: {
        enabled: true,
        levelSeparation: 100,
        nodeSpacing: 50,
        direction: direction_us_network,
        layout: layoutMethod_us_network
      },
    };
    network_us_network = new vis.Network(container_us_network, data_us_network, options_us_network);

</script>

